import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

/**This file gives data for
   the partition of the fundamental domain.  
   This is the most important data file.
   All the points are QIs except for point13,
   which is defined over a quartic number field.*/

public class DataPartition {


    /**These are the pieces of the partition.  The indices of the
       vertices are listed.  Pieces 50,51,52,... are preset regions
       for the polygon selection window.*/

    public static int[] pointList(int k) {
	int[][] s={
            {2,6,7},{32,76,5,8},{72,68,21,75},{1,21,75,80},{1,69,9},
	    {1,9,12},{19,17,24,23},{17,18,25,24},{23,24,33,20},{24,25,34,33},
            {39,40,46,45},{40,41,47,46},{45,46,52,51},{46,47,53,52},{18,16,26,25},
            {87,88,23,20,12},{87,88,28,12},{9,16,13,30,3,69},
            {25,26,35,34},{20,35,42,41,40,39,38,37,56,12},
            {56,37,43},{37,38,44,43},{66,57,99,8,68,69,67},{9,19,23,28},{38,39,45,44},
            {41,42,48,47},{56,43,49},{43,44,50,49},{44,45,51,50},{69,21,68},
            {47,48,54,53},{55,56,49,50,51,52,53,54},{3,30,29,74},
            {75,80,5,76,32,72},{29,10,13,30},
            {55,15,56},{64,58,59,60,61,62,63},{3,66,67},
            {68,8,32,72},{1,2,65,70},
            {57,6,7,5,8,99},{8,5,98,99},{5,98,57,111,108,22},
            {90,22,108,111,57},{107,22,90,57,96},
            {107,96,93,97,112,22},{99,98,57},{100,101,102,103},
            {112,22,7,6,93,97},{35,42,104,105},
            {2,10,15},{110,2,12},{12,110,10,15},{1,21,68,8,5}};
	return(s[k]);
    }

    /**This routine tells which semigroup element is attached
       to each piece of the partition.*/

    public static int[] image(int k) {

	int[][] t={
       {1,1,1,0},{1,1,1,0},{0,3,1,0},{1,0,1,0},{1,0,1,0},
       {1,0,1,0},{0,2,1,0},{0,2,1,0},{1,4,1,0},{1,4,1,0},
       {0,4,1,0},{0,4,1,0},{1,1,1,0},{1,1,1,0},{0,2,1,0},
       {1,4,1,0},{1,4,1,0},{1,4,1,0},{1,4,1,0},{0,2,1,0},
       {0,4,1,0},{0,4,1,0},{1,4,1,0},{0,2,1,0},{0,4,1,0},
       {0,4,1,0},{1,1,1,0},{1,1,1,0},{1,1,1,0},{1,1,1,0},
       {1,1,1,0},{1,3,1,0},{0,3,1,0},{1,1,1,0},{0,0,1,1},
       {0,0,1,1},{0,0,1,1},{1,1,1,0},{1,3,1,0},{1,1,0,0},
       {0,3,1,0},{0,1,1,0},{1,1,1,0},{1,3,1,0},{0,1,1,0},
       {1,1,1,0},{1,1,1,0},{1,0,1,0},{1,1,1,0},{1,1,1,0}};

	return(t[k]);
    }


    /**Here is the data for the vertices of the partition.*/

public static long[] data1() {long[] x={1,0,1,0};return(x);}
public static long[] data2() {long[] x={0,0,0,0};return(x);}
public static long[] data3() {long[] x={0,1,1,-1};return(x);}
public static long[] data4() {long[] x={-2,2,2,-1};return(x);}
public static long[] data5() {long[] x={33,-20,33,-20};return(x);}
public static long[] data6() {long[] x={15,-9,-39,24};return(x);}
public static long[] data7() {long[] x={5,-3,5,-3};return(x);}
public static long[] data8() {long[] x={-12,8,-16,10};return(x);}
public static long[] data9() {long[] x={1,1,-7,5};return(x);}
public static long[] data10() {long[] x={5,8,-2,-3};return(x);}
public static long[] data11() {long[] x={5,8,1,0};return(x);}
public static long[] data12() {long[] x={1,1,1,1};return(x);}
public static long[] data13() {long[] x={5,8,9,-5};return(x);}
public static long[] data14() {long[] x={14,-8,-3,2};return(x);}
public static long[] data15() {long[] x={5,8,5,8};return(x);}
public static long[] data16() {long[] x={5,8,-7,5};return(x);}
public static long[] data17() {long[] x={2,3,-7,5};return(x);}
public static long[] data18() {long[] x={6,2,-7,5};return(x);}
public static long[] data19() {long[] x={5,0,-7,5};return(x);}
public static long[] data20() {long[] x={5,0,-1,2};return(x);}
public static long[] data21() {long[] x={14,-8,-4,3};return(x);}
public static long[] data22() {long[] x={2,-1,2,-1};return(x);}
public static long[] data23() {long[] x={5,0,0,1};return(x);}
public static long[] data24() {long[] x={12,-3,8,-4};return(x);}
public static long[] data25() {long[] x={3,4,-5,4};return(x);}
public static long[] data26() {long[] x={5,8,16,-9};return(x);}
public static long[] data27() {long[] x={5,0,-1,2};return(x);}
public static long[] data28() {long[] x={1,1,0,1};return(x);}
public static long[] data29() {long[] x={3,1,-2,-3};return(x);}
public static long[] data30() {long[] x={6,-2,-14,8};return(x);}
public static long[] data31() {long[] x={-1,6,8,-7};return(x);}
public static long[] data32() {long[] x={22,-13,2,-1};return(x);}
public static long[] data33() {long[] x={1,4,-1,2};return(x);}
public static long[] data34() {long[] x={5,3,-1,2};return(x);}
public static long[] data35() {long[] x={5,8,-1,2};return(x);}
public static long[] data36() {long[] x={-3,3,-3,2};return(x);}
public static long[] data37() {long[] x={3,2,14,-5};return(x);}
public static long[] data38() {long[] x={2,3,28,-14};return(x);}
public static long[] data39() {long[] x={-10,11,42,-23};return(x);}
public static long[] data40() {long[] x={-1,6,-2,4};return(x);}
public static long[] data41() {long[] x={1,6,4,0};return(x);}
public static long[] data42() {long[] x={5,8,-8,7};return(x);}
public static long[] data43() {long[] x={58,-32,27,-13};return(x);}
public static long[] data44() {long[] x={2,3,-1,4};return(x);}
public static long[] data45() {long[] x={-10,11,5,0};return(x);}
public static long[] data46() {long[] x={17,-5,-5,6};return(x);}
public static long[] data47() {long[] x={6,3,14,-6};return(x);}
public static long[] data48() {long[] x={5,8,-14,11};return(x);}
public static long[] data49() {long[] x={58,-32,-49,34};return(x);}
public static long[] data50() {long[] x={2,3,-38,27};return(x);}
public static long[] data51() {long[] x={-10,11,2,2};return(x);}
public static long[] data52() {long[] x={9,0,0,3};return(x);}
public static long[] data53() {long[] x={-2,8,11,-4};return(x);}
public static long[] data54() {long[] x={5,8,1,2};return(x);}
public static long[] data55() {long[] x={5,8,6,0};return(x);}

public static long[] data58() {long[] x={-250,0,-12,8};return(x);}
public static long[] data59() {long[] x={-2,-3,-12,8};return(x);}
public static long[] data60() {long[] x={-4,0,122,-75};return(x);}
public static long[] data61() {long[] x={122,-75,-4,0};return(x);}
public static long[] data62() {long[] x={-12,8,-2,-3};return(x);}  
public static long[] data63() {long[] x={-12,8,-250,0};return(x);} 
public static long[] data64() {long[] x={-250,0,-250,0};return(x);}

public static long[] data65() {long[] x={14,-9,-5,4};return(x);}
public static long[] data66() {long[] x={-5,4,14,-9};return(x);}
public static long[] data67() {long[] x={16,-9,-5,3};return(x);}
public static long[] data68() {long[] x={27,-16,-11,7};return(x);}
public static long[] data69() {long[] x={11,-6,-3,2};return(x);}
public static long[] data70() {long[] x={-5,3,16,-9};return(x);}
public static long[] data71() {long[] x={-20,13,-24,15};return(x);}
public static long[] data72() {long[] x={-20,13,36,-22};return(x);}
public static long[] data73() {long[] x={17,-10,-1,1};return(x);}
public static long[] data74() {long[] x={-20,15,-2,-3};return(x);}
public static long[] data75() {long[] x={22,-13,33,-20};return(x);}
public static long[] data76() {long[] x={-25,16,20,-12};return(x);}
public static long[] data77() {long[] x={4,0,4,0};return(x);}
public static long[] data78() {long[] x={-9,6,-55,34};return(x);}
public static long[] data79() {long[] x={2,1,-1,2};return(x);}
public static long[] data80() {long[] x={4,-2,4,-2};return(x);}
public static long[] data81() {long[] x={-6,4,-6,4};return(x);}
public static long[] data82() {long[] x={-4,3,5,-3};return(x);}
public static long[] data83() {long[] x={14,-8,-73,45};return(x);}
public static long[] data84() {long[] x={-20,13,16,-10};return(x);}
public static long[] data85() {long[] x={-20,13,16,-10};return(x);}
public static long[] data86() {long[] x={124,-76,-5,3};return(x);}
public static long[] data87() {long[] x={6,-2,4,-1};return(x);}
public static long[] data88() {long[] x={4,0,0,1};return(x);}
public static long[] data89() {long[] x={4,-2,5,-3};return(x);}
public static long[] data90() {long[] x={15,-9,-11,7};return(x);}
public static long[] data91() {long[] x={117,-72,65,-40};return(x);}
public static long[] data92() {long[] x={1,0,-2,1};return(x);}
public static long[] data93() {long[] x={38,-23,-99,61};return(x);}
public static long[] data94() {long[] x={-4,3,11,-7};return(x);}
public static long[] data95() {long[] x={-1,1,-8,5};return(x);}
public static long[] data96() {long[] x={16,-6,-7,8};return(x);}
public static long[] data97() {long[] x={12,-7,42,-26};return(x);}
public static long[] data98() {long[] x={145,-89,118,-73};return(x);}
public static long[] data99() {long[] x={-7,5,11,-7};return(x);}
public static long[] data100() {long[] x={-6,5,4,-2};return(x);}
public static long[] data101() {long[] x={31,-18,4,-2};return(x);}
public static long[] data102() {long[] x={-44,28,29,-17};return(x);}
public static long[] data103() {long[] x={8,-4,29,-17};return(x);}
public static long[] data104() {long[] x={10,9,-8,7};return(x);}
public static long[] data105() {long[] x={10,9,-1,2};return(x);}
public static long[] data106() {long[] x={-12,8,-250,0};return(x);}
public static long[] data107() {long[] x={25,-15,-68,42};return(x);}
public static long[] data108() {long[] x={12,-7,-3,2};return(x);}
public static long[] data109() {long[] x={-250,0,-12,8};return(x);}
    public static long[] data110() {long[] x={1,1,-1,0};return(x);}
public static long[] data111() {long[] x={119,-73,21,-13};return(x);}
public static long[] data112() {long[] x={7,-4,-16,10};return(x);}



    public static QI2[] point56() {
	QI a=new QI(-1,3);
	QI b=new QI(2,1);
	QI2 x=new QI2(a,b,1);
	QI2[] X={x,x};
	return(X);
    }

    public static QI2[] point57() {
	QI a=new QI(1,4);
	QI b=new QI(-2,-1);
	QI c=new QI(-5,-9);
	QI d=new QI(3,4);
	QI2 x=new QI2(c,d,1);
	QI2 y=new QI2(a,b,1);
	QI2[] X={x,y};
	return(X);
    }

    public static QI2[] point96() {
	QI a=new QI(0,1);
	QI b=new QI(0,0);
	QI c=new QI(1,-1);
	QI d=new QI(0,0);
	QI2 x=new QI2(a,b,1);
	QI2 y=new QI2(c,d,1);
	QI2[] X={x,y};
	return(X);
    }


    public static long[] data(long k) {
	if(k==1) return(data1());
	if(k==2) return(data2());
	if(k==3) return(data3());
	if(k==4) return(data4());
	if(k==5) return(data5());
	if(k==6) return(data6());
	if(k==7) return(data7());
	if(k==8) return(data8());
	if(k==9) return(data9());
	if(k==10) return(data10());
	if(k==11) return(data11());
	if(k==12) return(data12());
	if(k==13) return(data13());
	if(k==14) return(data14());
	if(k==15) return(data15());
	if(k==16) return(data16());
	if(k==17) return(data17());
	if(k==18) return(data18());
	if(k==19) return(data19());
	if(k==20) return(data20());
	if(k==21) return(data21());
	if(k==22) return(data22());
	if(k==23) return(data23());
	if(k==24) return(data24());
	if(k==25) return(data25());
	if(k==26) return(data26());
	if(k==27) return(data27());
	if(k==28) return(data28());
	if(k==29) return(data29());
	if(k==30) return(data30());
	if(k==31) return(data31());
	if(k==32) return(data32());
	if(k==33) return(data33());
	if(k==34) return(data34());
	if(k==35) return(data35());
	if(k==36) return(data36());
	if(k==37) return(data37());
	if(k==38) return(data38());
	if(k==39) return(data39());
	if(k==40) return(data40());
	if(k==41) return(data41());
	if(k==42) return(data42());
	if(k==43) return(data43());
	if(k==44) return(data44());
	if(k==45) return(data45());
	if(k==46) return(data46());
	if(k==47) return(data47());
	if(k==48) return(data48());
	if(k==49) return(data49());
	if(k==50) return(data50());
	if(k==51) return(data51());
	if(k==52) return(data52());
	if(k==53) return(data53());
	if(k==54) return(data54());
	if(k==55) return(data55());
	/**56 and 57 are special*/
	if(k==58) return(data58());
	if(k==59) return(data59());
	if(k==60) return(data60());
	if(k==61) return(data61());
	if(k==62) return(data62());
	if(k==63) return(data63());
	if(k==64) return(data64());
	if(k==65) return(data65());
	if(k==66) return(data66());
	if(k==67) return(data67());
	if(k==68) return(data68());
	if(k==69) return(data69());
	if(k==70) return(data70());
	if(k==71) return(data71());
	if(k==72) return(data72());
	if(k==73) return(data73());
	if(k==74) return(data74());
	if(k==75) return(data75());
	if(k==76) return(data76());
	if(k==77) return(data77());
	if(k==78) return(data78());
	if(k==79) return(data79());
	if(k==80) return(data80());
	if(k==81) return(data81());
	if(k==82) return(data82());
	if(k==83) return(data83());
	if(k==84) return(data84());
	if(k==85) return(data85());
	if(k==86) return(data86());
	if(k==87) return(data87());
	if(k==88) return(data88());
	if(k==89) return(data89());
	if(k==90) return(data90());
	if(k==91) return(data91());
	if(k==92) return(data92());
	if(k==93) return(data93());
	if(k==94) return(data94());
	if(k==95) return(data95());
	if(k==96) return(data96());
	if(k==97) return(data97());
	if(k==98) return(data98());
	if(k==99) return(data99());
	if(k==100) return(data100());
	if(k==101) return(data101());
	if(k==102) return(data102());
	if(k==103) return(data103());
	if(k==104) return(data104());
	if(k==105) return(data105());
	if(k==106) return(data106());
	if(k==107) return(data107());
	if(k==108) return(data108());
	if(k==109) return(data109());
	if(k==110) return(data110());
	if(k==111) return(data111());
	if(k==112) return(data112());
	return(null);
    }




}

