import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

/**This class generally manages the data contained in the file
   DataPartition*/

public class DataPartitionManager {
    public static int TOTAL=50; //pieces


    public static void assignDomain(Manager M,int n) {
	 QI2Polygon temp=piece(n);
	 System.out.println("assignDomain: piece: "+n);
	 if(temp!=null) {
           M.P.DOMAIN=piece(n);
	   int q=M.P.DOMAIN.COUNT;
	   SelectStyle.NUMBER1=q;
	   try{M.S.NUMBER1.val=q;}
	   catch(Exception e) {}
	 }
    }



    /**This gives the kth polygon in the partition, numerically.*/

    public static PolyVector pieceN(int k) {
	int[] t=DataPartition.pointList(k);
	return(poly(k,t));
    }

    /**The actual points*/

    public static QI2[] point(int k) {
	if(k==56) return(DataPartition.point56());
	if(k==57) return(DataPartition.point57()); 
	if(k==96) return(DataPartition.point96()); 
        long[] x=DataPartition.data(k);
	QI2[] X={new QI2(x[0],x[1]),new QI2(x[2],x[3])};
	return(X);
    }


    /**This gives the kth polygon in the partition.
       The coordinates are given exactly in terms of QIs.*/


    public static QI2Polygon piece(int k) {
	int[] t=DataPartition.pointList(k);
	QI2[][] V=new QI2[t.length][2];
	for(int i=0;i<t.length;++i) {
	    V[i]=point(t[i]);
	}
	QI2Polygon P=new QI2Polygon(V);
	return(P);
    }



    /**This gets numerical versions of the points.*/

    public static double[] pointN(int k) {
	QI2[] a=point(k);
	double[] d={a[0].toDouble(),a[1].toDouble()};
	return d;
    }


    /**This routine assembles the polygon from
       the individual points.*/

    public static PolyVector poly(int k,int[] t) {
	int n=t.length;
	PolyVector P=new PolyVector();
	P.tag=t;
	P.name=k;
	P.count=n;
	int[] z=DataPartition.image(k);
	if(z!=null) P.image=z;
	for(int j=0;j<n;++j) {
	    double[] x=pointN(t[j]);
	    P.V[j].x[0]=x[0];
	    P.V[j].x[1]=x[1];
	    P.V[j].x[2]=1;
	}
	return(P);
    }

    /**This routine returns a string which gives the
       numerical coordinate of the kth point.*/

    public static String toString(int k) {
	double[] x=pointN(k);
	Double[] X=new Double[2];
	if(SpecialAffine.GO==true) x=SpecialAffine.map(x);
	String S0=GraphicsHelp.clean(x[0]);
	String S1=GraphicsHelp.clean(x[1]);
	String S=S0+"  "+S1;
	return(S);
    }


    /**This routine returns a string which gives the
       exact quadratic irrational coordinate of the point.*/

    public static String toStringQI(int k) {
      QI2[] X=point(k);
      String S0=X[0].toString();
      String S1=X[1].toString();
      String S2=S0+"      "+S1;
      return(S2);

    }

    /**This returns the index of the partition point which is
       closest to the given point*/

    public static int index(double x,double y) {
	double min=1000000;
	int index=0;
	for(int i=1;i<113;++i) {
	    double[] p=pointN(i);
	    double test=(p[0]-x)*(p[0]-x)+(p[1]-y)*(p[1]-y);
	    if(test<min) {
		index=i;
		min=test;
	    }
	}
	return(index);
    }




}



