import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class Documentation {

    public Documentation() {}

    public static void explain(Manager M,String S) {
	try{
          M.D.setExplain(S);
          M.D.repaint();
	  M.repaint();
	}
	catch(Exception e) {}
    }

    public static void tileControlInfo(Manager M) {
        String S="tile control";

	S=S+"\n\nThese boxes work in tandem with the triang and tri image features on the display panel. When these two features are turned on, you can click on a piece in the partition and see its image under the relevant map.  Some of these pieces are rather small and it is tedious to have to click in them.  These boxes index all the pieces of the partition.  When you click on one of the boxes, you select the center of the corresponding piece of the partition.";
	S=S+"\n\n--magenta: pieces which cover the Cantor subset JC. These pieces map over themselves in a purely expansive way.";
        S=S+"\n\n--light red: pieces which cover the Anosov attractor JA. These pieces map over themselves in a hyperbolic (Anosov) way.  The dynamics here is like that of the Smale horseshoe.";
	S=S+"\n\n--green: pieces which contain a part of J but which are mapped disjointly from themselves.  These pieces are stretched over JA in a hyperbolic way.";
	S=S+"\n\n--cyan: These pieces are disjoint from JC but lie in the component of the core covering JC.  The heat map carries these pieces outside the core.";
	S=S+"\n\n--orange: These pieces are disjoint from JC but lie in the component of the core covering JC.  The second iteration of the heat map carries these pieces outside the core.";

        S=S+"\n\n--blue: pieces which are disjoint from J.  The second iterate of the heat semigroup carries these pieces into the convex region.";
	S=S+"\n\n--purble: pieces containing a vertex which is a repelling fixed point. The map stretches these pieces over themselves, eitherly in a purely expansive way or in a hyperbolic way.";
	S=S+"\n\n--navy: These pieces all map into the space of convex polygons after one iteration.";
	S=S+"\n\n--dark red: These auxiliary pieces do not lie in the fundamental domain the the Gauss group.  However, they are useful for controlling the images of some of the other pieces.";

	S=S+"\n\nThere are 4 additional small tiles which are not accessible through this control panel.  These tiles are not part of the partition; they abut pieces 6-13are contained in pieces 19 and 31.  The extra tiles are used in a technical step in our proof, to control the images of the top and bottom edges of pieces 6-13.";
        
        explain(M,S);
    }

    public static void tileFillInfo(Manager M) {
        String S="tile fill control";
	S=S+"\n\nThis lever toggles whether or not you fill in the pieces of the partition.  The display can get rather confusing when the pieces are filled in, but the filling does show how the boxes on the control panel correspond to the pieces of the partition.";
        
        explain(M,S);
    }

    public static void tileSubdivideInfo(Manager M) {
        String S="tile refine control";
	S=S+"\n\nFor the resulst in the paper having to do with the structure of the Julia set, one of the pieces gives us trouble, and we need to subdivide it.  When you set this lever to the right, it replaces the original piece by a subdivision into 7 smaller pieces, and also calls forth several new pieces which contain the images of some of these pieces under the relevant maps.  The 7 pieces in the refinement are colored according to the following scheme";

	S=S+"\n\nmedium cyan: On these pieces, the relevant map is nonsingular.  This means that the local structure of the Julia set in these pieces is inherited from the local structure of the Julia set in the image of these pieces.";

	S=S+"\n\ndark cyan: These pieces are disjoint from the Julia set. In each case, the associated map carries these pieces in to regions we have previously shown to be disjoint from the Julia set.";

	S=S+"\n\nlight cyan: On these pieces the vector dM(1,0) is transverse to the Julia set.  Here M is the primary element associated to the piece in question.";

	S=S+"\n\nAnother nice feature of these pieces is that the interiors of the edges common to a pair of these pieces are disjoint from the Julia set.  This gives rise to a kind of divide and conquer approach to the Julia set within the original piece.";
        
        explain(M,S);
    }



    public static void displayInfo(Manager M) {
        String S="display panel";

	S=S+"\n\nThis panel lets you display some auxiliary objects associated with the system.  You click on the leftmost squares to change the color and you click on the middle squares to toggle (on/off) the display.";
	S=S+"\n\nIf you want to chance the display color, you should open up the PLOT DETAILS popup window and select a new color on the color wheel at the bottom of that window.  As an exercise in color changing, press reset, turn on the 'star' feature, and try to change its color to blue.";
        
        explain(M,S);
    }


    public static void formulaDisplay(Manager M) {
        String S="formula display";

	S=S+"\n\nThis window displays the formulas for main maps.  The main maps comprise a semigroup.  The building blocks of the semigroup are as follows:";

	S=S+"\n\nThe projective midpoint map H.";
	S=S+"\n\nThe change of coordinates map B.";
	S=S+"\n\nThe Gauss group \u0393.";

	S=S+"\n\nThe semigroup is generated by BHB^{-1} and B\u0393B^{-1}.  You can see formulas for the various semigroup elements by clicking on the `semigroup' button.  The formulas are complicated, and probably you will not care about the formulas, but they serve as a debugging device:  You can take the simpler formulas, multiply them together in some auxiliary program like Mathematica, and compare the answer to what we display.";

	S=S+"\n\nWhy do we conjugate by B?  Even though this makes the algbraic formulas quite complicated, the geometry is much better.  The conjugated Gauss group B\u0393B^{-1} has a Euclidean triangle for a fundamental domain.  Also, the conjugated midpoint map BHB^{-1} has fixed points at (0,0) (1,1) and (\u221E,\u221E).  Our conjugation is somehow canonical.";

	S=S+"\n\nWhen you select a new map on the green map selector, a new formula will be displayed.  There are 10 elements of the Gauss group and 10 primary elements.  The primary elements all have the form";

	S=S+"\n\n B R^i G^j H B^{-1}\n\n";
	S=S+"Here R and G are the generators of \u0393.";


        explain(M,S);
    }


    public static void specialMapInfo(Manager M) {
        String S="auxiliary map";

	S=S+"\n\nRecall that H is the projective midpoint map and B is the coordinate change.  Open up the FORMULAS window to see formulas for these maps.  The auxiliary map is B^{-1}H.  This map does not belong to our semigroup but nonetheless it is very useful to us.";
	S=S+"\n\nThe auxiliary map is used in the monograph to see that no point in the partition pieces A,B,C,D lie in the Julia set.  This amounts to showing that Z maps each of these pieces into the unit square [0,1]^2.  This is verified using the confiner test.  As an exercise, try to locate one of the tiles A,B,C,D and notice how the assigned primary map changes to the auxiliary map.  Hint: The A,B,C,D pieces are amongst the largest ones in the partition.";
        
	S=S+gaussAction();
        explain(M,S);
    }



    public static void mapInfo(Manager M) {
        String S="map selector";

	S=S+"\n\nThese buttons let you select an element of the semigroup.  You can either select an element of the Gauss group or a primary element. If you open up the FORMULAS window you can see formulas for the maps you select.  Generally speaking, we attach a primary element to each piece of the partition.  When you click the middle mouse button (or the key x) on the piece, the primary map changes.  As an exercise, try clicking on some pieces of the partition and see how the primary map changes. If you want to see the action of the given primary map (or an element of the Gauss group) you can use the pointer feature. ";

	S=S+gaussAction();
        
        explain(M,S);
    }





    public static void frameInfo(Manager M) {
        String S="display panel: frame";

	S=S+"\n\nThe frame consists of a large square and a large blue triangle.  The corners of the square coincide with the corners of the unbounded green domain consisting of points which represent convex pentagon classes.  The triangle is our fundamental domain for the action of the Gauss group.  Most of the action in this program takes place within this blue triangle.  The triangle is bounded by the lines of slope 1 and -1/\u03D5^2 through the origin, and the vertical line through the point x=\u03D5^6.";

	S=S+gaussAction();
        
        explain(M,S);
    }

    public static void starInfo(Manager M) {
        String S="display panel: star";

	S=S+"\n\nThis shows the piecewise analytic disk consisting of points which represent star convex pentagon classes.  This set is somewhat larger than the core, which contains the invariant Cantor set.  In particular, the invariant Cantor set is contained in the star region.  We don't use the star region for any purpose in our program, but it is nice to see where it is for reference.  The star region is invariant under the Gauss group, and 10 pieces are orbits of a single triangle under the action of the Gauss group.  The single triangle has vertices (0,0), (\u03D5^2,\u03D5^2), (\u03D5,-1).";

	S=S+gaussAction();
        
        explain(M,S);
    }


    public static void coreInfo1(Manager M) {
        String S="display panel: core";
	S=S+"\n\nThe core is a piecewise analytic disk which contains the invariant Cantor set JC from the monograph.  This disk is invariant under the action of the Gauss group.";

        S=S+Documentation.gaussAction();
        Documentation.explain(M,S);
        
    }

    public static void pointerInfo(Manager M) {
        String S="display panel: pointer";

	S=S+"\n\nThis draws a line segment from the point P you select to the image f(P), where f is the selected map. You select a map using the green map window.  You can select either a Gauss group element or a primary map.  You can drag the middle mouse button over the picture window to see the pointer continuously move.";
	
        S=S+gaussAction();
        explain(M,S);
    }

    public static void triInfo(Manager M) {
        String S="display panel: tiling";
	S=S+triang();
	S=S+gaussAction();
        
        explain(M,S);
    }

    public static void triSelectInfo(Manager M) {
        String S="display panel: tri select";
	S=S+"\n\nWhen this feature is on, the picture screen will highlight a piece of the fundamental partition if you select a point in it. You do this using the middle mouse button or key-x.";
	S=S+"\n\nPress the info button for the 'tri' feature to learn about the fundamental partition.";
        
        explain(M,S);
    }




    public static void triImageInfo(Manager M) {
        String S="display panel: triangulation image";

	S=S+"\n\nTo each small polygon, we have attached a primary element of the heat semigroup.  Such an element is a composition of the first power of the heat map and some element of the Gauss group. When this feature is on, you select a polygon of the partition by clicking the middle mouse (or using the x-key) in it. Then the window displays the polygon and its image under the associated map. The plot density keys on the bottom window control the detail of the plot.";
	S=S+"\n\nPress the info button for the 'tri' feature to learn about the fundamental partition.";
        
        explain(M,S);
    }

    public static void partitionSelect(Manager M) {
	String S="Partition control.";
	S=S+"\n\nOur approach is to subdivide the fundamental domain (the blue triangle) into about 40 smaller polygons. This window lets you access the pieces in the partition.  First, and independent of this window, you can always select a piece of the partition by clicking the middle mouse button over that piece.  Second, if you click one of the rectangles in the cluster of buttons on this window then you select an associated partition piece.  The buttons in the cluster are laid out in a way which roughly reflection the combinatorics of the partition.  Third, you can type in a letter and then press the yellow button. If the letter corresponds to a partition piece, then this piece will be selected.  When you select a piece, the name we gave the piece in the monograph is displayed.\n\n";

	S=S+"\n\nThsis window has several other features:";
	S=S+"\n\nYou can choose to fill the partition pieces with solid colors.  The pieces are colored according to the role that they play in the proof.  For instance, the bright red pieces comprise the quasi-horseshoe.";
	S=S+"\n\nYou can subdivide the piece A1 of the partition into 7 smaller pieces, according to the scheme in Part 3 of the monograph.";
	S=S+"\n\nYou can print out the vertices of the partition piece.  I added this feature so that I could include the vertices in the appendix of the monograph.  The two vertices which do not lie in Z[\u03D5] just print out as letters (qq and rr).";

	explain(M,S);
    }



    public static String triang() {

 	String S="\n\nThe blue triangle is a fundamental domain for the Gauss group.  To understand the dynamics of the projective midpoint map, it suffices to understand what happens inside this fundamental domain.  We have partitioned this big blue triangle into about 40 convex polygons. The action of the map is fairly simple on each small polygon.  When we prove results about the structure of the Julia set J we analyze what the map does to each individual piece.  We also keep track of several polygons that lie outside the fundamental domain because these are needed in our analysis.";

	S=S+"\n\nYou can select pieces in the partition in two ways. You can either click the middle mouse button on them, or you can open up the PARTITION window and click on the buttons there.  The tiles in the partition are named A,B,C,... as in the monograph.  When you select a tile, its name appears in the upper left corner of the picture window.  As practice, try selecting some of the tiles.";
	return(S);
    }


    public static String julia() {

	String S="\n\nThe Julia set J is the set of points in the plane which do not land in the unbounded green region under iteration of the map BHB^{-1}.  We have colored points in the rest of the plane according to how long it takes them to get into the green region under iteration.  This gives a good impression of what J is like.";
return(S);
    }


    public static String selectedMap() {
	String S="\n\nSelected map: Using the green map selection buttons, you select some of the elements generated by the elements of the Gauss group and the map H.  The code ijk stands for the element";
	S=S+"\n\nB R^i G^j H^k B^{-1}.";
	S=S+"\n\nOpen up the FORMULAS window to see the definition of these maps.";
S=S+gaussAction();
    return(S);
    }




    public static String gaussAction() {
	String S="\n\nGAUSS GROUP AND PRIMARY MAPS:";

	S=S+"\n\nThis documentation is so important that we repeat it often.\n\n The Gauss group \u0393 is the order 10 action on the plane obtained by expressing the action of dihedrally relabeling a pentagon in our local coordinates. Open up the FORMULAS popup window to see the formulas for \u0393.  On the green map selector, these elements have codes";
	S=S+"\n\n000 010 020 030 040 100 110 120 130 140";
	S=S+"\n\nThe code ij0 stands for the element BR^iG^jB^{-1} where R and G are generators for \u0393 and B is a certain change of coordinates.";
	S=S+"\n\nWe are mostly interested in the composition of the map H with the elements of \u0393.  These are what we call the primary maps.  They have the form BR^iG^jHB^{-1}.  On the green map selector, they have codes";

	S=S+"\n\n001 011, 021 031 041 101 111 121 131 141";

	S=S+"\n\nClick on the FORMULAS popup window to see formulas for these maps.";

return(S);
    }




}



