import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class FormulaCanvas extends ScaleCanvas implements MouseListener  {
    Manager M; 
    ControlPanel SELECT;

     public FormulaCanvas() {
	 addMouseListener(this);
	 setPanels();
     }

    public void setPanels() {  
	Color[] C0={new Color(200,0,200),
		    Color.white,Color.white,
                    Color.white,
                    new Color(180,180,180)};
	String[] SelectString={"basic maps",
			       "semigroup elt. coord. 1","semigroup elt. coord. 2","maps"};
	int[] SelectState={1,0,0};
        SELECT=new ControlPanel(C0,SelectString,SelectState,3);
	SELECT.mode=0;
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;  
      g.setColor(new Color(0,0,255));
      g.fillRect(0,0,getWidth(),getHeight());
      SELECT.render(g,5,5,150);	
      int[] a=M.C.MC.getMap();
      main(g,SELECT.mode,a);
    }


    public static boolean main(Graphics2D g,int choice,int[] a) {

	if(choice==0) {
           drawMapUntransformed(g);
	   drawCoordChange(g);
	   drawGaussGroup(g);
	}

	if(choice!=0) {
	   g.translate(0,150);
	   drawChoice(g,a);
	   g.translate(0,-150);

	   g.translate(5,-70);
	   drawMap(choice-1,g,a);
	   g.translate(-5,70);
	}
	g.setStroke(new BasicStroke(1));
	return(true);
    }

    public static void drawMapUntransformed(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.setColor(Color.yellow);
	g.drawString("projective midpoint map",110,95);
	g.setColor(Color.white);
        g.drawString("H(x,y)=(h(x,y),h(y,x))",20,137);
	g.translate(10,100);
	g.drawString("h(x,y)=",10,90);
	g.drawString("(-3+2xy+xy^2)(6-x-6xy+x^2y^2)",100,80);
	g.drawLine(90,88,420,88);
	g.drawString("(-3+x-y+4xy+xy^2)(6-y-6xy+x^2y^2))",83,110);
	g.translate(-10,-100);
    }

    public static void drawGaussGroup(Graphics2D g) {
	g.setColor(new Color(50,100,255));
	g.fillRect(230,190,300,300);
	g.translate(210,80);
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.translate(-20,180);
	g.setColor(Color.yellow);
	g.drawString("Gauss group",90,-30);
	g.setColor(Color.white);
	g.drawString("\u0393=<R,G>",60,0);
        g.drawString("G(x,y)=",60,90);
	g.drawString("1-x",158,80);
	g.drawLine(156,83,190,83);
	g.drawString("1-xy",158,100);
	g.drawString("(",145,93);
	g.drawString(")",200,93);
	g.drawString("R(x,y)=(y,x)",60,45);
	g.drawString("R^2=G^5=Identity",60,130);
	g.drawString("RH=HR and GH=HG",60,160);
	g.translate(20,-130);
	g.translate(-210,-80);

    }

    public static void drawCoordChange(Graphics2D g) {
	g.setColor(new Color(0,0,160));
	g.fillRect(0,250,260,300);
	g.translate(20,270);
	g.setColor(Color.yellow);
        g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.drawString("coordinate change",10,20);
	g.setColor(Color.white);
	g.drawString("B(x,y)=(b(x),b(y))",10,60);
	g.translate(0,60);
        g.drawString("b(t)",10,60);
        g.drawString("=",47,60);
	g.drawString("\u03D5^3(\u03D5+t)",77,45);
	g.drawLine(70,55,180,55);
	g.drawString("-1+\u03D5 t",90,75);	
	g.drawString("\u03D5=(1+\u221A 5)/2",10,130);
 	g.translate(-20,-270);  
    }


    public static void drawChoice(Graphics2D g,int[] a) {
	g.setColor(new Color(0,0,200));
	g.fillRect(165,-150,500,100);
	g.setColor(Color.yellow);
        g.setFont(new Font("Helvetica",Font.PLAIN,30));
	Integer[] A=new Integer[3];
	g.translate(-140,-145);
	g.drawString("H",305,40);
	for(int i=0;i<3;++i) {
	    A[i]=new Integer(a[i]);
	    g.drawString(A[i].toString(),335+18*i,50);
	}

	g.drawString("=",400,40);
	g.drawString("B",435,40);
	g.drawString("R",460,40);
	g.drawString("G",490,40);
	g.drawString("H",523,40);
	g.drawString("B",557,40);

        g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.drawString(A[0].toString(),478,22);
	g.drawString(A[1].toString(),510,22);
	g.drawString(A[2].toString(),543,22);
	g.drawString("-1",577,22);


        g.setFont(new Font("Helvetica",Font.PLAIN,30));
	g.drawString("=(P1/Q1,P2/Q2)",360,80);
	g.translate(140,145);
    }

    public static void drawMap(int choice,Graphics2D g,int[] a) {
	if(a[2]>1) return;
  	QI2RationalMap F=new QI2RationalMap();
	if(a[2]==0) F=DataGauss.map(a);
	if(a[2]==1) F=DataMap.map(a);
 	Color C1=Color.white;
	g.drawLine(170,180,170,585);
	g.drawLine(345,180,345,585);
	g.drawLine(515,180,515,585);
	F.F[choice].P.render(g,10,235,C1);
	F.F[choice].Q.render(g,185,235,C1);
        g.setFont(new Font("Helvetica",Font.PLAIN,30));
	if(choice==0) {
	  g.drawString("P1=",50,210);
	  g.drawString("Q1=",225,210);
	}
	if(choice==1) {
	  g.drawString("P2=",50,210);
	  g.drawString("Q2=",225,210);
	}
    }









    public void mousePressed(MouseEvent e) { 
    }

     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   

     public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	int d=SELECT.switchMode(J.X);
	if(d==99) Documentation.formulaDisplay(M);
	repaint();
     }

}
