import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class Animator implements Runnable {
    Manager M;
    int halt;
    int[][] WORD=new int[500][20];
    PolyVector[] POLY=new PolyVector[500];
    int COUNT;
    boolean CONVEX;

    public Animator() {}
    public Animator(Manager MM) {
	this.M=MM;
        COUNT=0;
	CONVEX=false;
    }


    public void run() {
	int mode=M.C.ItC.MOVIE.mode;
	if(mode==0) orbit();
  	if(mode==1) movie();
    }



    public void movie() {
	M.T.clear();
	halt=1;
	double WAIT=10000000;
	int count=0;
	double old=0;
	double cur=0;
	double dif=0;
	while(halt==1) {
	    ++COUNT;
	    int k=M.C.ItC.CYCLE.val;
            PolyVector V=M.I.V[0].normalize();
	    check(V);

            V=NewMap.map(M.C.ItC.WORD,V);
	    V=NewMap.cycle(k,V);
	    V=Reshape.reshape(V,M.C.ItC.getNormalize());
	    double[] d=XInvariants.invariant(V);

	    cur=product(d);
	    dif=cur-old;
	    double d1=XTests.logVariance(V);
	    sendMessage(d1,cur);
	    old=cur;
            M.I.V[0]=V;
	    M.I.repaint();
	    WAIT=10000000*Math.pow(2.0,8-M.C.ItC.getMovieSpeed());
	    wait(WAIT);
	}
	halt=0;
	M.T.clear();
	M.repaint();
    }


    public static void check(PolyVector V0) {
	double[] d0=XInvariants.invariant(V0);
	PolyVector V1=NewMap.map1(V0);
	double[] d1=XInvariants.invariant(V1);
	PolyVector V2=NewMap.map2(V0);
	double[] d2=XInvariants.invariant(V2);
	PolyVector V12=NewMap.map1(V2);
	double[] d12=XInvariants.invariant(V12);
	PolyVector V21=NewMap.map2(V1);
	double[] d21=XInvariants.invariant(V21);
	PolyVector V11=NewMap.map1(V1);
	double[] d11=XInvariants.invariant(V11);


	double test1=change(d0,d1);
	double test2=change(d0,d2);;
	double test12=change(d0,d12);
	double test21=change(d0,d21);
	double test11=change(d0,d11);

	double[] test={test1,test2,test12,test21,test11};
	for(int i=0;i<5;++i) System.out.println(test[i]);
	System.out.println("-----");
    }

    public static double change(double[] d1,double[] d2) {
	double t=1;
	for(int i=0;i<d1.length;++i) {
	    t=t*d2[i]/d1[i];
	}
	return t;
    }


    public void orbit() {
	int mode=M.C.ItC.getNormalize();
        PolyVector V=M.I.V[0].normalize();
	V=NewMap.map(M.C.ItC.WORD,V);
	V=Reshape.reshape(V,mode);
        M.I.V[0]=V;
    }

    public void sendMessage(double d1,double d2) {
	    TextCanvas.MESSAGE[0]="movie running "+COUNT;
	    Double D=new Double(d1);
	    TextCanvas.MESSAGE[1]="log variance "+D.toString();
	    D=new Double(d2);
	    TextCanvas.MESSAGE[2]="energy "+D.toString();
	    M.T.repaint();
    }


    public void wait(double n) {
	for(int i=0;i<n;++i);
    }

    public double product(double[] d) {
	double p=1;
	for(int i=0;i<d.length;++i) {
	    p=p*d[i];
	}
	p=Math.pow(p,1.0/d.length);
        return(p);
    }

    public void print(double[] d) {
	for(int i=0;i<d.length;++i) System.out.print(d[i]+" ");
	System.out.println("");
    }



    public void doTest(PolyVector V0) {

	double[] a0=XInvariants.invariant(V0);
	double b0=product(a0);
	PolyVector V1=NewMap.map1(V0);
	double[] a1=XInvariants.invariant(V1);
	double b1=product(a1);
	double b2=b1-b0;
	System.out.println(b2);

    }



}

