import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



    /**these routines give the user control of the
       partition via the control panel.*/


public class HandleTile {
    int X,Y; //location of control panel 
    ListenSquare I; //documentation
    ListenSquare[][] BOX=new ListenSquare[9][6];
    Color[][] COL=new Color[9][6];
    int[][] PIECE=new int[9][6];
    int CHOICE;  //this is the currently chosen box

    public HandleTile(int x,int y) {
	X=x;
	Y=y;
	presetBoxes();
	setBoxes(X,Y);
	COL=initialColors();
	setPieces();
	CHOICE=14;
    }

    public void presetBoxes() {
	for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
		BOX[i][j]=new ListenSquare(0,0,0,0);
	    }
	}
    }


    public void setBoxes(int x,int y) {
	for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
		BOX[i][j]=new ListenSquare(0,0,0,0);
	    }
	}


	int a=x+20;
	int b=y+60;
	BOX[0][0]=new ListenSquare(a,b-24,36,12);
	BOX[1][0]=new ListenSquare(a+12,b-36,24,12);
	BOX[7][3]=new ListenSquare(a,b-36,12,12);

	for(int i=0;i<2;++i) {
	    for(int j=1;j<4;++j) {
		BOX[i][j]=new ListenSquare(a+12*j+24,b-12*i-24,12,12);
	    }
	}

	for(int i=3;i<=4;++i) {
	    for(int j=0;j<6;++j) {
		BOX[i][j]=new ListenSquare(a+12*j,b-12*i-24,12,12);
	    }
	}


	/**The 7 tiles in the subdivision*/
        BOX[2][0]=new ListenSquare(a-60,b-00,12,12);
        BOX[5][4]=new ListenSquare(a-60,b-12,12,12);
        BOX[5][5]=new ListenSquare(a-60,b-24,12,12); 
        BOX[7][2]=new ListenSquare(a-60,b-36,12,12);
        BOX[8][0]=new ListenSquare(a-60,b-48,12,12);
        BOX[6][3]=new ListenSquare(a-60,b-60,12,12);
        BOX[8][1]=new ListenSquare(a-60,b-72,12,12);

	/**The 2 extra tile related to the subdivision*/
        //BOX[7][5]=new ListenSquare(a+48,b+51,12,12); 
        //BOX[8][2]=new ListenSquare(a+60,b+51,12,12); 

        BOX[2][1]=new ListenSquare(a,b-48,72,12);
	BOX[6][2]=new ListenSquare(a,b-84,72,12);
	BOX[2][5]=new ListenSquare(a,b-96,72,12);   //top
	BOX[5][2]=new ListenSquare(a,b-12,72,36);
	BOX[6][5]=new ListenSquare(a+24,b+24,48,24);
	BOX[6][1]=new ListenSquare(a,b+36,24,12);
	BOX[6][4]=new ListenSquare(a,b+24,24,12);
	BOX[2][3]=new ListenSquare(a-48,b-36,36,12);
	BOX[7][1]=new ListenSquare(a-48,b+36,24,12);
        BOX[5][3]=new ListenSquare(a-48,b-12,36,12);
        BOX[7][0]=new ListenSquare(a-36,b-24,12,12);
        BOX[0][5]=new ListenSquare(a-24,b+12,24,12);
	BOX[5][1]=new ListenSquare(a-24,b+36,24,12);   
	BOX[0][4]=new ListenSquare(a-48,b+24,48,12);    //triangular piece touching origin
	BOX[1][5]=new ListenSquare(a-48,b-24,12,12);
	BOX[1][4]=new ListenSquare(a-24,b-24,12,12);
	BOX[2][2]=new ListenSquare(a-24,b,24,12);
	BOX[5][0]=new ListenSquare(a-12,b-36,12,24); 
	BOX[6][0]=new ListenSquare(a-12,b-12,12,12);     //expander

 	BOX[7][4]=new ListenSquare(a-48,b,24,24); //covering piece

	/**info*/
	I=new ListenSquare(a+60,Y-52,12,12);  
    }	




    public Color[][] initialColors() {
	Color[][] C=new Color[9][6];
        for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
		C[i][j]=new Color(0,120,40);
        	if((i>2)&&((j==3)||(j==4))) C[i][j]=new Color(255,0,50);
        	if((i<2)&&((j==1)||(j==2))) C[i][j]=new Color(255,0,50);
		if((i==2)||(i>=5)) C[i][j]=new Color(0,0,255);
	    }
	}

	C[6][5]=new Color(0,0,120);
	C[2][5]=new Color(0,0,120);
	C[0][4]=new Color(255,0,255);
	C[2][3]=new Color(255,0,255);
	C[1][4]=new Color(255,0,255);
	C[1][5]=new Color(255,0,255);
	C[5][0]=new Color(120,0,200);
	C[6][4]=new Color(0,180,0);
	C[6][0]=new Color(120,0,200);
	C[6][1]=new Color(180,0,0);
	C[2][4]=new Color(0,0,255);
	C[0][5]=new Color(0,230,230);
	C[6][2]=new Color(0,0,255);
	C[5][4]=new Color(120,255,255);
	C[6][3]=new Color(120,255,255);
	C[5][3]=new Color(240,120,0);
	C[7][0]=new Color(240,120,0);
	C[7][1]=new Color(180,0,0);
	C[2][2]=new Color(0,230,230);
	C[7][4]=new Color(0,230,230);
	C[7][5]=new Color(120,0,200);
	C[5][1]=new Color(120,0,0);
	C[3][0]=new Color(0,205,0);
	C[4][0]=new Color(0,205,0);
	C[2][0]=new Color(0,220,220);
	C[5][5]=new Color(0,140,140);
	C[7][2]=new Color(0,230,230);
	C[8][3]=new Color(0,230,230);
	C[8][0]=new Color(0,140,140);
	C[8][1]=new Color(0,230,230);
	C[8][2]=new Color(100,0,255);
	return(C);
    }

    public void setPieces() {
	int[][] P={{23,6,7,14,0,22},
                   {15,8,9,18,2,1},
                   {48,19,29,3,-1,35},
                   {20,21,24,10,11,25},
                   {26,27,28,12,13,30},
                   {5,39,17,38,45,44},
                   {4,32,31,46,37,34},
		   {33,36,43,16,40,49},
                   {42,41,47,-1,-1,-1}};
	for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
		PIECE[i][j]=P[i][j];
	    }
	}
    }

    public int getVertexCount() {
	QI2Polygon P=DataPartitionManager.piece(CHOICE);
	return(P.COUNT);
    }

    public void render(Graphics2D g) {	
        g.setFont(new Font("Helvetica",Font.PLAIN,11));
	for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
		boolean test=shouldDraw(i,j);
		if(test==true)
		BOX[i][j].render(g,COL[i][j]);
	    }
	}
	I.infoRender(g);
    }


    public boolean shouldDraw(int i,int j) {
	int n=PIECE[i][j];
	int q=SelectPartition.SUB;
	if((n==40)&&(q==1)) return(false);
	if((n> 40)&&(q==0)) return(false);
	return(true);
    }


    public int process(Point X,Manager M) {
	if(I.inside(X)==1) return(99);
	boolean sub=false;
	if(SelectPartition.SUB==1) sub=true;
	for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
	      if(BOX[i][j].inside(X)==1) {
		  int n=PIECE[i][j];

		  if((n<41)||(sub==true)) {
                      setPiece(n,M);
		      return(0);
		  }
		  if((n==40)&&(sub==false)) {
                      setPiece(n,M);
		      return(0);
		  }
	      }
	    }
	}
	return(0);
    }




    public void setPiece(int n,Manager M) {
	 CHOICE=n;
	 int[] on={SelectStyle.AUTO1,SelectStyle.AUTO2};
	 if(on[0]==1) DataPartitionManager.assignDomain(M,n);
	 if(on[1]==1) DataConfiner.assignRange(M,n);
	 PolyVector P=DataPartitionManager.pieceN(n); 
	 double[] z=P.cheapInterior();
	 M.P.SOURCE=new Complex(z[0],z[1]);
         M.C.MC.G[0].val=P.image[0];  
	 M.C.MC.G[1].val=P.image[1];  
	 M.C.MC.G[2].val=P.image[2];  
	 M.C.MC.G[3].val=P.image[3]; 
	 int[] J=getBox(n);
	 COL=initialColors();
	 COL[J[0]][J[1]]=Color.yellow;
    }

    public void forceBox(int k) {
	CHOICE=k;
	int[] x=getBox(k);
	if(x!=null) {
	    COL=initialColors();	
            COL[x[0]][x[1]]=Color.yellow;
	}
    }

    public Color getColor(int k) {
	int[] x=getBox(k);
	Color[][] C=initialColors();
	Color COL=C[x[0]][x[1]];
	return(COL);
    }

    /**finds the index of the box which controls the given piece*/
    public int[] getBox(int k) {
	int[] X={-1,-1};
	for(int i=0;i<9;++i) {
	    for(int j=0;j<6;++j) {
		if(PIECE[i][j]==k) {
		    X[0]=i;
		    X[1]=j;
		    return(X);
		}
	    }
	}
        return(null);
    }

}
