#! /usr/local/bin/wish  -f

canvas .plot -width 400 -height 400
pack .plot
canvas .post -width 400 -height 20 -bg white
pack .post

.post create rectangle 0 0 80 20 -fill blue -tag export
.post create text 10 10 -text "export" -anchor w -fill white -tag export

.plot create line 0 0 0 0 -fill black -tag X -width 0
.plot itemconfigure X -width 2

proc post {} {
puts "START EXPORT"
global SIZE HEIGHT
.plot postscript -pageheight 400 \
-height 400 -width 400 \
-file "julia.ps"
puts "DONE"
}

######SCALING######################
set ACOORD 0
set BCOORD 0
set SCALE 1

bind .plot <Button-1> {location %x %y
		       up_scale}

bind .plot <Button-2> {location %x %y
   	               dn_scale}

bind .plot <Button-3> {location %x %y
   	               dn_scale}

proc location {a b} {
global ACOORD BCOORD
set ACOORD $a
set BCOORD $b
}

proc up_scale {} {
global ACOORD BCOORD SCALE 
set sc [expr 11.0/10.0]
set SCALE [expr $SCALE*$sc]
.plot scale X $ACOORD $BCOORD $sc $sc
}


proc dn_scale {} {
global ACOORD BCOORD SCALE 
set sc [expr 10.0/11.0]
set SCALE [expr $SCALE*$sc]
.plot scale X $ACOORD $BCOORD $sc $sc
}
######################################

##############creation of picture#####

set TEST 0

proc doTest {i j} {
    global TEST
    set TEST 0
    set r [expr ($i * $i) + ($j * $j) ]
    if {$r<40000} {set TEST 1}
}




for {set i 0} {$i<400} {incr i} {
for {set j 0} {$j<400} {incr j} {
    global TEST
    doTest $i $j
    set COLOR "blue"
    if {$TEST == 1} {set COLOR "red"}
    
    .plot create rectangle $i $j [expr $i+1] [expr $j+1] -fill blue -outline $COLOR -tag X}
}


##########exporting##############


.post bind export <Any-Button> post
