import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;




public class QI2Excluder implements Runnable {
    QI2RationalMap MAP;
    QI2Polygon DOMAIN;
    QI2Polygon EXCLUDER;
    QITestWrapper QIT;
    int TRI;
    long TIME;
    MonitorTests MT;
    int STRICT;


    public QI2Excluder() {}

    public QI2Excluder(QITestWrapper qit,QI2RationalMap x,QI2Polygon u,QI2Polygon v,int strict) {
	MAP=x;
	DOMAIN=u;
	EXCLUDER=v;
	QIT=qit;
	TIME=time();
	MT=QIT.M.TC.MT;
	DOMAIN.survey=true;
	STRICT=strict;
    }



    public void run() {
       sendInit();
       boolean bad=false;
       QI2Polygon[] PIECES=DOMAIN.toSubdivision();  
       QIT.M.P.TR.COUNT=0; //reset polygon tracer
       int i=0;
       while((bad==false)&&(i<PIECES.length)&&(QIT.HALT==false)) {
	   TRI=i;
	   sendState();
           boolean test=isExcluded(MAP,PIECES[i],EXCLUDER);
	   if(test==false) {
             bad=true;
	     MT.STATE=2;  
             MT.S[0]="test fail";
	     QIT.HALT=true;
	     QIT.M.repaint();
	   }
	   ++i;
       }
       if(bad==false) {
	   MT.STATE=1; 
           MT.S[0]="test pass"; 
           QIT.M.repaint();
       }
       
       QIT.HALT=true;  
       QIT.M.repaint();
    }



    /**If this routine returns true, it implies that X(T) is disjoint from V.
       This time T is a triangle.*/

    public boolean isExcluded(QI2RationalMap X,QI2Polygon T,QI2Polygon V) {
	QI2Polygon[] LIST={T};
	int count=0;
	int record=0;
	int test=0;
	while((QIT.HALT==false)&&(LIST.length>0)) {
	    ++count;
	    QI2Polygon U=LIST[LIST.length-1];
	    if(record<U.age) record=U.age;  
            sendDepth(U.age,record,count);
	    test=oneSide(X,U,V);
	    if(test!=-1) LIST=QI2Polygon.truncate(LIST);
	    else LIST=QI2Polygon.refine(LIST);
	    if(record>7) return(false);
	}
	if(QIT.HALT==true) return(false);
	return(true);
    }

    public int oneSide(QI2RationalMap X,QI2Polygon U,QI2Polygon V) {
	QI2[] CU=U.interiorPoint();
	QI2[] CV=V.interiorPoint();
	QI2RationalMap I=QI2RationalMap.identityMap();
	for(int i=0;i<V.COUNT;++i) {
	    int j=(i+1)%V.COUNT;
	    QI2[] P=V.V[i];
	    QI2[] Q=V.V[j];
	    QI2RationalFunction F=X.confineRational(P,Q);
            QI2RationalFunction L=I.confineRational(P,Q);
	    int su=QI2Polynomial.evaluateSign(F,CU);
	    int sv=L.evaluateSign(CV);
	    QI2Polynomial Y=new QI2Polynomial(F.P);
	    if(su*sv==-1) {
	      U.testnumber=i;
	      U.color=i;
	      int test=checkDominance(Y,U);
	      if(test!=0) return(i);
	    }
	}
	return(-1);
    }



    public int checkDominance(QI2Polynomial Y,QI2Polygon WW) {
	QI2Polygon W=new QI2Polygon(WW);
	for(int i=0;i<3;++i) {
	    int sign=Y.checkDominance(W,STRICT);
	   W.testnumber=WW.testnumber;
	   W.color=WW.color;
	   if(sign!=0) {
	       sendPoly(W); 
               return(sign);
	   }
	   W=W.rotate();
	}
	return(0);
    }






    /**communication with monitor*/

    public void sendPoly(QI2Polygon W) {
	Tracer TR=QIT.M.P.TR;
	int c=TR.COUNT;
	TR.LIST[c]=W;
	++TR.COUNT;
    }

    public void sendInit() {
	String S="excluder test  ";
	Integer E=new Integer(EXCLUDER.COUNT);
	int c=DOMAIN.COUNT;
	Integer T=new Integer(c-2);
	S=S+T.toString()+" triangles";
	MT.S[0]=S;
    }

    public void sendState() {
	Integer I2=new Integer(TRI+1);
        MT.S[1]="triangle "+I2.toString();
    }

    public void sendDepth(int a,int b,int c) {
	MT.DEPTH[0]=a;
	MT.DEPTH[1]=b;
	MT.DEPTH[2]=c;
	MT.TIME=time()-TIME;
	QIT.M.repaint();
    }

    public static long time() {
	long t=System.currentTimeMillis();
	return(t);
    }






}







