import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**Manages the auxiliary triangulations generated by the tests.*/

public class Tracer {
   QI2Polygon[] LIST=new QI2Polygon[3000];
   int COUNT;
    int INDEX;

   public Tracer() {}

    /**Draws the auxiliary triangulations generated by the
       tests.*/

    public void render(PictureCanvas P,Graphics2D g) {
	INDEX=-1;
	for(int i=0;i<COUNT;++i) {
	    PolyVector X=LIST[i].toDouble();
	    Path2D.Double gp=X.toPath();
	    Color C=getColor(LIST[i].color);
	    g.setColor(C);
	    boolean test1=LIST[i].survey;
	    boolean test2=gp.contains(P.SOURCE.x,P.SOURCE.y);
            if((test1==true)&&(test2==true)) {
		INDEX=i;
		g.setColor(Color.yellow);
	    }   
            gp=P.transform(gp);
            g.fill(gp);
	    g.setColor(Color.white);
	    g.draw(gp);
	}
    }


    public Color getColor(int i) {
	if(i==0) return(new Color(30,50,255));
	if(i==1) return(new Color(0,200,0));
	if(i==2) return(new Color(255,50,0));
	if(i==3) return(new Color(0,100,100));
	if(i==4) return(new Color(200,0,100));
	if(i==5) return(new Color(100,0,200));
	if(i==6) return(new Color(200,0,0));
	return(Color.black);
    }

    public QI2Polygon getPoly() {
	if(INDEX==-1) return(null);
	return(LIST[INDEX]);
    }

}


